/*
Copyright (c) 2010 Nokia Corporation and/or its subsidiary(-ies). All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this
 list of conditions and the following disclaimer.
* Redistributions in binary form must reproduce the above copyright notice,
 this list of conditions and the following disclaimer in the documentation
 and/or other materials provided with the distribution.
* Neither the name of Nokia Corporation nor the names of its contributors
 may be used to endorse or promote products derived from this software
 without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

Description: 
*/

#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <unistd.h>

/**
 Wait for a key press.
*/

void PressKey()
    {
    int ch;
    printf("Press 'e'+Enter to exit\n");
    while((ch = getchar()) != 'e')
        {
        if(ch == '\n')
            continue;
        else
            printf("wrong option inserted, try again!!!\n");
        }
    }

/**
 Entry point for the raiseSignal process.
 The raiseSignal process obtains the PID of sigtermSignal, and sends the SIGTERM signal to it.
 */
int main(int argc,char **argv)
    {
    pid_t id;
    int ret;
    if(argc < 2)
        {
        printf("Please pass the correct arguments\n");
        return EXIT_FAILURE;
        }
    id = atoi(argv[1]);
	
    printf("*********************In the raiseSignal***********************\n");
    printf("\nThis process sends a SIGTERM signal to the sigtermSignal process.\n");
    printf("\nPress Enter to send the SIGTERM signal\n");
    getchar();
    
    //Raising SIGTERM signl using kill command.
    ret = kill(id, SIGTERM);
    if(ret)
        {
        printf("Kill() failed, errno=%d", errno);
        } 
    PressKey();
    return EXIT_SUCCESS;
    }
